#include "lanhep.h"

static Integer ferm_ind[8];



static char mb_buf[12];

static Atom mk_gamma(int t, int n)
	{
	if(t==-1)
		return NewAtom("G5",0);
	if(t==-2)
		return NewAtom("(1+G5)",0);
	if(t==-3)
		return NewAtom("(1-G5)",0);
	
	sprintf(mb_buf,"G(%c%d)",t?(t==2?'M':'p'):'m',n);
	return NewAtom(mb_buf,0);
	}

static Atom mk_cnvl(int t1, int n1, int t2, int n2)
	{
	if(t1>t2)
		{
		int tmp;
		tmp=t1;
		t1=t2;
		t2=tmp;
		tmp=n1;
		n1=n2;
		n2=tmp;
		}
	if(t1==t2 && n1>n2)
		{
		int tmp;
		tmp=n1;
		n1=n2;
		n2=tmp;
		}
	sprintf(mb_buf,"%c%d.%c%d",t1?(t1==2?'M':'p'):'m',n1,
			t2?(t2==2?'M':'p'):'m',n2);

	return NewAtom(mb_buf,0);
	}

static void m_reduce(Term m2, List pl, int pis, int fr)
	{
	List l,l1,lg,ls;

/*
	WriteTerm(m2); WriteTerm(pl); printf("  fi: %d %d\n", IntegerValue(ferm_ind[0]), 
		IntegerValue(ferm_ind[1]));
*/

	l1=NewList();
	lg=NewList();
	
	ls=l=ConsumeCompoundArg(m2,3);
	
	while(!is_empty_list(l))
		{
		Term t;
		t=ListFirst(l);
		/*ChangeList(l,0);*/
		if(t==0) goto cnt;
		if(CompoundName(t)==A_MOMENT)
			{
			List l2;
			Integer mi;
			int ppp=1;
			if(CompoundArg1(t)==0) goto cnt;
			mi=ListFirst(CompoundArg2(t));
			l2=pl;
			while(!is_empty_list(l2))
				{
				Term t1;
				t1=CompoundArg2(ListFirst(l2));
				if(CompoundName(t1)==OPR_VECTOR && ListFirst(CompoundArg1(t1))==mi)
					{
					l1=AppendLast(l1,mk_cnvl(1,IntegerValue(CompoundArg1(t)),0,ppp));
					goto cnt;
					}
				if(CompoundName(t1)==OPR_TENSOR && ListFirst(CompoundArg1(t1))==mi)
					{
					l1=AppendLast(l1,mk_cnvl(1,IntegerValue(CompoundArg1(t)),0,ppp));
					goto cnt;
					}
				if(CompoundName(t1)==OPR_TENSOR && ListNth(CompoundArg1(t1),2)==mi)
					{
					l1=AppendLast(l1,mk_cnvl(1,IntegerValue(CompoundArg1(t)),2,ppp));
					goto cnt;
					}
				ppp++;
				l2=ListTail(l2);
				}
			l2=ls;
			while(!is_empty_list(l2))
				{
				Term t1;
				t1=ListFirst(l2);
				if(CompoundName(t1)==OPR_SPECIAL && 
					CompoundArg1(t1)==A_GAMMA &&
					ListNth(CompoundArg2(t1),3)==mi)
					{
					Term tg;
					tg=MakeCompound(A_GAMMA,3);
					SetCompoundArg(tg,1,ListFirst(CompoundArg2(t1)));
					SetCompoundArg(tg,2,ListNth(CompoundArg2(t1),2));
					SetCompoundArg(tg,3,mk_gamma(1,IntegerValue(CompoundArg1(t))));
					lg=AppendLast(lg,tg);
					ChangeList(l2,0);
					goto cnt;
					}
				l2=ListTail(l2);
				}
			l2=ListTail(l);
			while(!is_empty_list(l2))
				{
				Term t1;
				t1=ListFirst(l2);
				if(CompoundName(t1)==A_MOMENT && 
					ListFirst(CompoundArg2(t1))==mi)
					{
					l1=AppendLast(l1,mk_cnvl(1,IntegerValue(CompoundArg1(t)),
											1,IntegerValue(CompoundArg1(t1))));
					SetCompoundArg(t1,1,0);
					goto cnt;
					}
				l2=ListTail(l2);
				}
			printf("Internal error in vertex "); WriteVertex(pl); printf(":");
			printf(" (milf)\n");
			goto cnt;				
			}
			
		if(CompoundName(t)==OPR_SPECIAL && CompoundArg1(t)==A_DELTA)
			{
			Integer i1,i2;
			List l2;
			int p1=-1,p2=-1, pp1=-1, pp2=-1;
			int ppp=1;
			i1=ListFirst(CompoundArg2(t));
			i2=ListNth(CompoundArg2(t),2);
			l2=pl;
			while(!is_empty_list(l2))
				{
				Term t1;
				t1=CompoundArg2(ListFirst(l2));
				if(CompoundName(t1)==OPR_VECTOR && ListFirst(CompoundArg1(t1))==i1)
					{
					p1=ppp;
					pp1=0;
					}
				if(CompoundName(t1)==OPR_TENSOR && ListFirst(CompoundArg1(t1))==i1)
					{
					p1=ppp;
					pp1=0;
					}
				if(CompoundName(t1)==OPR_TENSOR && ListNth(CompoundArg1(t1),2)==i1)
					{
					p1=ppp;
					pp1=2;
					} 
				if(CompoundName(t1)==OPR_VECTOR && ListFirst(CompoundArg1(t1))==i2)
					{
					p2=ppp;
					pp2=0;
					}
				if(CompoundName(t1)==OPR_TENSOR && ListFirst(CompoundArg1(t1))==i2)
					{
					p2=ppp;
					pp2=0;
					}
				if(CompoundName(t1)==OPR_TENSOR && ListNth(CompoundArg1(t1),2)==i2)
					{
					p2=ppp;
					pp2=2;
					}

				ppp++;
				l2=ListTail(l2);
				}
			if(p1!=-1 && p2!=-1)
				{
				l1=AppendLast(l1,mk_cnvl(pp1,p1,pp2,p2));
				goto cnt;
				}
			if(p1!=-1 || p2!=-1)
				{
				printf("Internal error in vertex "); WriteVertex(pl); printf(":");
				puts(" (dilf)");
				}
			goto cnt;	
			}
				
		if(CompoundName(t)==OPR_SPECIAL && CompoundArg1(t)==A_GAMMA)
			{
			Integer mi;
			List l2;
			Term tg;
			int ppp=1;
			tg=MakeCompound(A_GAMMA,3);
			SetCompoundArg(tg,1,ListFirst(CompoundArg2(t)));
			SetCompoundArg(tg,2,ListNth(CompoundArg2(t),2));
			mi=ListNth(CompoundArg2(t),3);
			l2=pl;
			while(!is_empty_list(l2))
				{
				Term t1;
				t1=CompoundArg2(ListFirst(l2));
				if(CompoundName(t1)==OPR_VECTOR && ListFirst(CompoundArg1(t1))==mi)
					{
					SetCompoundArg(tg,3,mk_gamma(0,ppp));
					lg=AppendLast(lg,tg);
					goto cnt;
					}
				if(CompoundName(t1)==OPR_TENSOR && ListFirst(CompoundArg1(t1))==mi)
					{
					SetCompoundArg(tg,3,mk_gamma(0,ppp));
					lg=AppendLast(lg,tg);
					goto cnt;
					}
				if(CompoundName(t1)==OPR_TENSOR && ListNth(CompoundArg1(t1),2)==mi)
					{
					SetCompoundArg(tg,3,mk_gamma(2,ppp));
					lg=AppendLast(lg,tg);
					goto cnt;
					}
				ppp++;
				l2=ListTail(l2);
				}
			l2=ListTail(l);
			while(!is_empty_list(l2))
				{
				Term t1;
				t1=ListFirst(l2);
				if(CompoundName(t1)==A_MOMENT && 
					ListFirst(CompoundArg2(t1))==mi)
					{
					SetCompoundArg(tg,3,mk_gamma(1,IntegerValue(CompoundArg1(t1))));
					lg=AppendLast(lg,tg);
					ChangeList(l2,0);
					goto cnt;
					}
				l2=ListTail(l2);
				}
			printf("Internal error in vertex "); WriteVertex(pl); printf(":");
			printf(" (gilf)\n");
			goto cnt;				
			}
		
		if(CompoundName(t)==OPR_SPECIAL && CompoundArg1(t)==A_GAMMA5)
			{
			Term tg;
			tg=MakeCompound(A_GAMMA,3);
			SetCompoundArg(tg,1,ListFirst(CompoundArg2(t)));
			SetCompoundArg(tg,2,ListNth(CompoundArg2(t),2));
			SetCompoundArg(tg,3,mk_gamma(-1,0));
			lg=AppendLast(lg,tg);
			goto cnt;
			}
		if(CompoundName(t)==OPR_SPECIAL && CompoundArg1(t)==A_GAMMAP)
			{
			Term tg;
			tg=MakeCompound(A_GAMMA,3);
			SetCompoundArg(tg,1,ListFirst(CompoundArg2(t)));
			SetCompoundArg(tg,2,ListNth(CompoundArg2(t),2));
			SetCompoundArg(tg,3,mk_gamma(-2,0));
			lg=AppendLast(lg,tg);
			goto cnt;
			}
		if(CompoundName(t)==OPR_SPECIAL && CompoundArg1(t)==A_GAMMAM)
			{
			Term tg;
			tg=MakeCompound(A_GAMMA,3);
			SetCompoundArg(tg,1,ListFirst(CompoundArg2(t)));
			SetCompoundArg(tg,2,ListNth(CompoundArg2(t),2));
			SetCompoundArg(tg,3,mk_gamma(-3,0));
			lg=AppendLast(lg,tg);
			goto cnt;
			}
	cnt:
		l=ListTail(l);
		}
	
/*	
	if(g5s)
		l1=AppendLast(l1,g5s);
	if(gs)
		l1=AppendLast(l1,gs);
	WriteTerm(l1); WriteTerm(pl); puts("");
*/	
	
	FreeAtomic(ls);
	
	if(fr==0 && !is_empty_list(lg))
		{
		printf("Error in vertex "); WriteVertex(pl); printf(":");
		puts(" gamma-matrices in the vertex without fermions");
		return ;
		}
	
	
	if(!is_empty_list(lg))
		{
		Label lab;
		ls=NewList();
		lab=ferm_ind[0];
	res:	
		l=lg;
		if(lab==ferm_ind[1])
			{
			if(!is_empty_list(lg))
				{
				printf("Error in vertex "); WriteVertex(pl); printf(":");
				printf(" a trace gamma^a^a^mu.\n");
				return ;
				}
			goto mkg_exi;
			}
		if(is_empty_list(lg))
			{
			printf("Error in vertex "); WriteVertex(pl); printf(":");
			printf(" bad spinor structure. ");
			puts("");
			return ;
			}
		while(!is_empty_list(l))
			{
			if(CompoundArg1(ListFirst(l))==lab)
				{
				ls=AppendLast(ls,CompoundArgN(ListFirst(l),3));
				lab=CompoundArg2(ListFirst(l));
				lg=CutFromList(lg,l);
				goto res;
				}
			l=ListTail(l);
			}
		printf("Error in vertex "); WriteVertex(pl); printf(":");
		printf(" bad spinor structure.");
		puts("");
		return ;
	mkg_exi:
		l1=ConcatList(l1,ls);
		}
		
		

			
	SetCompoundArg(m2,3,l1);
		
	}

static int prt_inds(List p)
	{
	int ret;
	ret=0;
	while(!is_empty_list(p))
		{
		ret+=ListLength(CompoundArg1(CompoundArg2(ListFirst(p))));
		p=ListTail(p);
		}
	return ret;
	}
		


void alg2_reduce(Term a2)
	{
	
		List l,prt;
		int pis,fr=0;
		
/*		printf("a2: "); WriteTerm(a2); puts("");*/
		prt=CompoundArg1(a2);
		{	/* Gluon vertices test */
		
		/*
		if(ListLength(prt)==4 && CompoundArg1(ListFirst(prt))==A_GLUON &&
			CompoundArg1(ListNth(prt,2))==A_GLUON && 
			CompoundArg1(ListNth(prt,3))==A_GLUON &&
			CompoundArg1(ListNth(prt,4))==A_GLUON)
				{
				Term m1;
				m1=ListFirst(CompoundArgN(a2,5));
				m1=CompoundArg1(ListFirst(CompoundArg2(m1)));
				SetCompoundArg(a2,3,m1);
				SetCompoundArg(a2,1,A_GLUON);
				SetCompoundArg(a2,2,NewInteger(4));
				SetCompoundArg(a2,5,
					NewAtom("m1.m3*m2.M3-m1.M3*m2.m3",0));
				l2=ListTail(l2);
				continue;
				}*/
		}
		pis=prt_inds(prt);
		l=prt;
		while(!is_empty_list(l))
			{
			if(CompoundName(CompoundArg2(ListFirst(l)))==OPR_SPINOR)
				{
				ferm_ind[fr]=ListFirst(CompoundArg1(CompoundArg2(ListFirst(l))));
				fr++;
				}
			l=ListTail(l);
			}
		if(fr!=0 && fr!=2)
			{
			printf("Error in vertex "); WriteVertex(prt); printf(":");
			printf(" %d fermions omitted in CompHEP output\n",fr);
			return;
			}
		l=CompoundArgN(a2,5);
		while(!is_empty_list(l))
			{
			m_reduce(ListFirst(l),prt,pis,fr);
			l=ListTail(l);
			}
	}		

	
	
	
